﻿Module Module1

    Private mstrMenuChoice As String

    Sub Main()

        ShowMenu()

        Do
            Select Case mstrMenuChoice
                Case "1"
                    Crash()
                Case "2"
                    HandleGeneralError()
                Case "3"
                    HandleSpecificError()
                Case "4"
                    IgnoreError()
                Case "5"
                    End
                Case Else
                    Console.WriteLine()
                    Console.Write("INVALID CHOICE. Enter the number corresponding to your selection: ")
                    mstrMenuChoice = Console.ReadLine
            End Select

        Loop


    End Sub

    Private Sub ShowMenu()

        Console.Clear()
        Console.WriteLine("*** TRY / CATCH ERROR HANDLING DEMO ***")
        Console.WriteLine()
        Console.WriteLine("Select an item from the list below:")
        Console.WriteLine()
        Console.WriteLine("1. Crash")
        Console.WriteLine("2. Handle General Error")
        Console.WriteLine("3. Handle Specific Error")
        Console.WriteLine("4. Ignore Error")
        Console.WriteLine("5. Exit")

        Console.WriteLine()
        Console.Write("Enter the number corresponding to your selection: ")
        mstrMenuChoice = Console.ReadLine

    End Sub

    Private Sub Crash()

        FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
        Console.WriteLine("File was opened successfully.")
        FileClose(1)

        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to Menu.")
        Console.ReadLine()
        ShowMenu()

    End Sub

    Private Sub HandleGeneralError()

        Try
            FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
            Console.WriteLine("File was opened successfully.")
            FileClose(1)
        Catch ex As Exception
            Console.WriteLine()
            Console.WriteLine("Error: " & ex.Message)
        Finally
            Console.WriteLine()
            Console.WriteLine("Press Enter to Return to Menu.")
            Console.ReadLine()
            ShowMenu()
        End Try

    End Sub

    Private Sub HandleSpecificError()

        Try
            FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
            Console.WriteLine("File was opened successfully.")
            FileClose(1)
        Catch ex As System.IO.FileNotFoundException
            Console.WriteLine()
            Console.WriteLine("Error: File 'JUNK.TXT' was not found.")
        Catch ex As System.IO.DriveNotFoundException
            Console.WriteLine()
            Console.WriteLine("Error: Drive 'E:' could not be accessed.")
        Catch ex As System.IO.DirectoryNotFoundException
            Console.WriteLine()
            Console.WriteLine("Error: Directory 'E:\' could not be accessed.")
        Catch ex As Exception
            Console.WriteLine()
            Console.WriteLine("Error: " & ex.Message)
        Finally
            Console.WriteLine()
            Console.WriteLine("Press Enter to Return to Menu.")
            Console.ReadLine()
            ShowMenu()
        End Try


    End Sub

    Private Sub IgnoreError()

        Try

            Try
                FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
                Console.WriteLine("File was opened successfully.")
                FileClose(1)
            Catch ex As Exception
                ' leave empty to effectively ignore any error
            End Try

            Console.WriteLine()
            Console.WriteLine("We don't know if file was opened successfully or not.")

        Catch ex As Exception
            ' nothing to really catch here

        Finally
            Console.WriteLine()
            Console.WriteLine("Press Enter to Return to Menu.")
            Console.ReadLine()
            ShowMenu()

        End Try
 
    End Sub

End Module
